'solve model with model consistent expectations

'include mce-subroutines
  	include  .\mce_solve_library

'arguments - %0
	if @isempty(%0)=1 then
		%mod = "_kvarts" 'default
		else
		%mod =%0 
	endif

'nostatus
	if @hasoption("nostatus")=0 then
		tic
		statusline The solveMCE add-in: starts ...
	endif

'aopts - from the mce_solve subroutine

	if @isempty(@equaloption("aopts"))=1 then
		'default 
		%aopts 	= "meth=qnewton, jinit=bd, m=200" 
		else
		%aopts =@equaloption("aopts")
	endif

		'jinit= 			
						'interp(n) 	calculate every nth column exactly and all other columns by interpolation
						'linear 		calculate only the subset of columns needed to construct the exact matrix of a linear MCE model
						'bd 			block-diagonal matrix
						'identity 		identity matrix

'solveopts
	if @isempty(@equaloption("solveopt"))=1 then
		%solveopts="o=b,g=12,z=1e-12, f=f, c=1e-11"
		else
		%solveopts =@equaloption("solveopt")
	endif


'find current alias name in the active scenario
	%active={%mod}.@endoglist("@active")  'list of all endogenous variables in active scenario
	%active=@word(%active,1) 'take the first variable (with active scenario alias)
	!start=@rinstr(%active,"_") 'find the starting position of underscore (starting in reverse)
	if !start=0 then
		%prompt="solveMCE: You must use a different scenario than ACTUALS when calling the solveMCE add-in"
		@uiprompt(%prompt)
		stop
		else

	endif
		%active=@mid(%active,{!start}) 'alias including the _
		%alias=@lower(%active)

'scenario to be used for initialising forward looking variables, defualt is the active scenario
	if @isempty(@equaloption("initalias"))=1 then
		'default 
		%initalias 	= %alias
		else
		%initalias =@equaloption("initalias")
	endif


'strings
	%wf									= @wfname 'name of current workfile
	%pagesmpl 						= @pagesmpl
	%pre_existing_content 			= @wflookup("*")
	%modb								= "_$_"+%mod+"_b" 'name given to modelB in mce_run-routie
	%modf								= "_$_"+%mod+"_f" 'name given to modelF in mce_run-routie
	%overridelist 						= @lower({%mod}.@overridelist("@active"))
	%excludelist 						= @lower({%mod}.@excludelist("@active"))
	%replace 							= "*"+%alias
	%overridelist 						= @wreplace(%overridelist,%replace, "*", "all")  'list with only variablenames (without alias)
	%scenarionameinmodel			= %alias '%scenarioname 'to be used in series when solved by the scenarioMCE addin

	'check that at least one variable is overridden in the active scenario
	if @isempty(%overridelist) = 1 then
		%prompt="solveMCE: No variables are overriden in the model: "+%mod+". Please specify a list of variables to be overriden using the override command, e.g.: "+%mod+".override() x1 x2 ... xN"
		@uiprompt(%prompt)
		stop
	endif

	'1 create auxiliary models and  find forward looking variables and copy from active scenario to actuals, only perform if active is not equal to actuals
	'2) execute simulation

	'statusline
	if @hasoption("nostatus")=0 then
		tic
		statusline The solveMCE add-in: Analysing model to find forward looking variables
	endif

'*******************************************************************************
'		Create auxiliary models and  find forward looking variables 
'*******************************************************************************

	%mopts1 = "create,mod=%mod" ',adds" ',track"
	%aopts1 = "" 	
	%sopts1 = "cleanup" 
	scalar createmodelsonly = 1 'scalar to instruct mce_run to only create model F and B if =1, and then stop (option/scalar added by Thomas von Brasch)
  	call mce_run(%mopts1,%aopts1,%sopts1, createmodelsonly,%solveopts,%scenarionameinmodel)
	%instrus 	= {%mod}_instrus
	%errs 		= {%mod}_targs

		'find forward looking variables
		%modbendog		= {%modb}.@endoglist
		%modfexog 		= {%modf}.@exoglist
		%forwardlooking 	= @wintersect(%modbendog, %modfexog)
		%_$_F_LD			= @wnotin(%modfexog , %modbendog) 'string with lead variables x_LD_1, or x_LD_2, ...


		'stop program if there are no forward looking variables
		if @isempty(%forwardlooking)=1 then
	
			'tidy up based on differences in workfile from the beginning of the program: saves only the models: %modB and %modF
				%after_existing_content = @wlookup("*")
				%to_delete = @wnotin(@lower(%after_existing_content), @lower(%pre_existing_content)) 
				%to_delete = @wnotin(@lower(%to_delete), @lower(%keep)) 'Add the created spool to list of things to keep
				delete {%to_delete}
				%keep = "" 
				%to_delete = "" 'empty string
	
			%prompt="solveMCE: No forward looking variables were found in the model. Please specify a model with forward looking variables"
			@uiprompt(%prompt)
			stop
		endif

		'copy initial values for forward looking variables

			'create vector that will hold all the lead terms, ie x(+n), the vectors will hold the different n's for all forward looking terms
			!forwardvariables = @wcount(%_$_F_LD)
			vector(!forwardvariables) _$_lead
	
			!iter=0
			for %LD {%_$_F_LD}
				!iter = !iter+1
				'find variable %v
					!ld= @instr(@upper(%LD), "_LD_")
					!left = !ld-1
					%v = @left(%ld, !left)
	
				'find lead
					!lead = !ld+4
					%lead = @mid(%ld, !lead)
				 	_$_lead(!iter)= @val(%lead)  'put lead term into vector to find the highest lead term
					%fvar = %v+@mid(%ld, !ld)
	
				'copy to actuals		
					%valias = %v+%initalias
					%zzz$$$yyy = "zzz$$$yyy_"+%v
						if @isobject(%valias)=1 then
							rename {%v} {%zzz$$$yyy}			'backup actuals (will be undone below)
							copy(o) {%v}{%initalias} {%v}		'copy to actuals, to get  the value for the final period. 
							copy {%v}{%initalias} {%fvar}	'copy to forward-looking variable in model B and F, se FRB/US documentation
							%keep = %keep + " " + %zzz$$$yyy 
						endif
	
			next

		'stores the max lead-term (to be used in the scenario-addin)
		if @hasoption("leadmax")=1 then
			delete(noerr) solveMCE_leadmax
			scalar solveMCE_leadmax = @max(_$_lead)
			!solveMCE_leadmax= solveMCE_leadmax
		endif


	'make new scenario with the specified alias name
  		{%modb}.scenario(n,a=%alias)   {%alias}
  		{%modf}.scenario(n,a=%alias)    {%alias}
	 	{%modb}.override {%overridelist}
		{%modb}.exclude {%excludelist}



'*******************************************************************************
'		 Execute simulation : mce_run: call routine
'*******************************************************************************

	'statusline
	if @hasoption("nostatus")=0 then
		tic
		statusline The solveMCE add-in: Solves the model
	endif

	'mce_run: options
 	%mopts = "mod_b=%modb,mod_f=%modf,mce_instrus=%instrus,mce_errs=%errs"
	%sopts 	= "type=single,scen,suf="+%alias 
		scalar createmodelsonly = 0 'scalar to instruct mce_run to only create model F and B if =1, and then stop (option/scalar added by Thomas von Brasch)
		winminimize(q) {%wf} 'minimize window
		call mce_run(%mopts,%aopts,%sopts,createmodelsonly,%solveopts,%scenarionameinmodel)

'copy back actuals and optionally deletes displaynames for forward looking variables
		for %v {%forwardlooking}
			'delete displayname for forward looking variables
				if @hasoption("nodisplayname")=1 then
						{%v}{%alias}.displayname 
				endif

			'copy back actuals
				%zzz$$$yyy = "zzz$$$yyy_"+%v
				if @isobject(%zzz$$$yyy)=1 then
					delete {%v}
					rename  zzz$$$yyy_{%v} {%v}
				endif
		next

'statusline
	if @hasoption("nostatus")=0 then
		!elapsed=@toc
		statusline The solveMCE add-in used {!elapsed} seconds to finish
	endif

'cleanup
	if @hasoption("norestore")=0 then
		'lists of objects to keep
		%modbendog={%modb}.@endoglist("@active")
		%spool = %mod+%alias
		%spool = @getnextname(%spool)
		rename mce_sim_spool {%spool}
		%keep = %modbendog + " "+%spool '%modb+ " "+ %modf 'object that will not be deleted
	
		'tidy up based on differences in workfile from the beginning of the program: saves only the models: %modB and %modF
		%after_existing_content = @wlookup("*")
		%to_delete = @wnotin(@lower(%after_existing_content), @lower(%pre_existing_content)) 
		%to_delete = @wnotin(@lower(%to_delete), @lower(%keep)) 'Add the created spool to list of things to keep
		delete {%to_delete}
	endif


'store strings

		' with forward-looking variables
		if @hasoption("forwardlooking")=1 then
			delete(noerr) forwardlooking
			string solveMCE_forwardlooking = %forwardlooking
		endif

		'with max lead term
		if @hasoption("leadmax")=1 then
			 scalar solveMCE_leadmax= !solveMCE_leadmax
		endif

'restore workfile
	if @hasoption("wfhide") then
		else
		winrestore {%wf} 'maximize window
	endif


